package dbclass;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import beans.Categoria;
import beans.Noticia;

public interface CategoriaDAO {
	
	public Categoria insert(Categoria categoria) throws SQLException, ClassNotFoundException;
	
	public Categoria update(Categoria categoria) throws SQLException, ClassNotFoundException;
	
	public boolean delete(long id) throws ClassNotFoundException, SQLException;
	
	public List<Categoria> findAll() throws SQLException, ClassNotFoundException;
	
	public Categoria findById(long id) throws SQLException, ClassNotFoundException;
	
	public List<Noticia> findAllNoticias(long id) throws ClassNotFoundException, SQLException;
	public ResultSet findTotal() throws SQLException, ClassNotFoundException;
	
}
