package dbclass;

import java.sql.SQLException;
import java.util.List;

import beans.Comentario;

public interface ComentarioDAO {
	
	public Comentario insert(Comentario comentario) throws SQLException, ClassNotFoundException;
	
	public Comentario update(Comentario comentario) throws SQLException, ClassNotFoundException;
	
	public boolean delete(long id) throws ClassNotFoundException, SQLException;
	
	public List<Comentario> findAll() throws SQLException, ClassNotFoundException;
	
	public Comentario findById(long id) throws SQLException, ClassNotFoundException;	
}
