package dbclass;

import java.sql.SQLException;
import java.util.List;

import beans.Imagem;

public interface ImagemDAO {
	
	public Imagem insert(Imagem imagem) throws SQLException, ClassNotFoundException;
	
	public Imagem update(Imagem imagem) throws SQLException, ClassNotFoundException;
	
	public boolean delete(long id) throws ClassNotFoundException, SQLException;
	
	public List<Imagem> findAll() throws SQLException, ClassNotFoundException;
	
	public Imagem findById(long id) throws SQLException, ClassNotFoundException;	
	public List<Imagem> findUsadas(long id) throws SQLException, ClassNotFoundException ;
	public List<Imagem> findNaoUsadas(long id) throws SQLException, ClassNotFoundException ;

}
