package dbclass;

import java.sql.SQLException;
import java.util.List;

import beans.Video;

public interface VideoDAO {
	
	public Video insert(Video video) throws SQLException, ClassNotFoundException;
	
	public Video update(Video video) throws SQLException, ClassNotFoundException;
	
	public boolean delete(long id) throws ClassNotFoundException, SQLException;
	
	public List<Video> findAll() throws SQLException, ClassNotFoundException;
	
	public Video findById(long id) throws SQLException, ClassNotFoundException;	
	
	public List<Video> findUsados(long id) throws SQLException, ClassNotFoundException ; 
	
	public List<Video> findNaoUsados(long id) throws SQLException, ClassNotFoundException ;

}
