package beans;

import java.util.List;

public class Noticia {
	long id;
	String titulo;
	String corpo;
	String data;
	String tags;
	long id_autor;
	long id_categoria;
	long nota;
	List<Imagem> imagens;
	List<Video> videos;  
	List<Comentario> comentarios;
	String nome_categoria;
	String nome_autor;
	
	Imagem imagem;
	Video video; 
	
	
	public Noticia(long id, String titulo, String corpo, String data,
			long id_autor, long id_categoria) {
		this.id = id;
		this.titulo = titulo;
		this.corpo = corpo;
		this.data = data;
		this.id_autor = id_autor;
		this.id_categoria = id_categoria;
		this.imagem = null;
		this.video = null;
	}
	

	public Noticia(long id, String titulo, String corpo, String data,
			long id_autor, long id_categoria, Imagem imagem, Video video) {
		super();
		this.id = id;
		this.titulo = titulo;
		this.corpo = corpo;
		this.data = data;
		this.id_autor = id_autor;
		this.id_categoria = id_categoria;
		this.imagem = imagem;
		this.video = video;
	}


	public Imagem getImagem() {
		return imagem;
	}

	public void setImagem(Imagem imagem) {
		this.imagem = imagem;
	}

	public Video getVideo() {
		return video;
	}

	public void setVideo(Video video) {
		this.video = video;
	}
	
	public long getId() {
		return id;
	}
	
	public void setId(long id) {
		this.id = id;
	}
	public String getTitulo() {
		return titulo;
	}
	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}
	public String getCorpo() {
		return corpo;
	}
	public void setCorpo(String corpo) {
		this.corpo = corpo;
	}
	public String getData() {
		return data;
	}
	public void setData(String data) {
		this.data = data;
	}
	public long getId_autor() {
		return id_autor;
	}
	public void setId_autor(long id_autor) {
		this.id_autor = id_autor;
	}
	public long getId_categoria() {
		return id_categoria;
	}
	public void setId_categoria(long id_categoria) {
		this.id_categoria = id_categoria;
	}
	public String data_ddmmyyyy() { 
		String d = this.data;
		return d.substring(8, 10)+ "-" + d.substring(5, 7) + "-" + d.substring(0, 4);
	
	}
	
	public String data_yyyymmdd() {
		String d = this.data;
		return d.substring(6, 10)+ "-" + d.substring(3, 5) + "-" + d.substring(0, 2);
	}
	public String getTags() {
		return tags;
	}

	public void setTags(String tags) {
		this.tags = tags; 
	}
	
	public List<Imagem> getImagens() {
		return imagens;
	}

	public void setImagens(List<Imagem> imagens) {
		this.imagens = imagens; 
	}	
	public List<Video> getVideos() {
		return videos;
	}

	public void setVideos(List<Video> videos) {
		this.videos = videos;  
	}
	public String getNomeCategoria() {
		return nome_categoria;
	}
	public void setNomeCategoria(String NomeCategoria) {
		this.nome_categoria = NomeCategoria;
	}
	public String getNomeAutor() {
		return nome_autor;
	}
	public void setNomeAutor(String nome_autor) {
		this.nome_autor = nome_autor;
	}
	public List<Comentario> getComentarios() {
		return comentarios;
	}

	public void setComentarios(List<Comentario> comentarios) {
		this.comentarios = comentarios;  
	}
	public long getNota() {
		return nota;
	}
	public void setNota(long nota) { 
		this.nota = nota; 
	}
}
