package dbclass;

import java.sql.SQLException;
import java.util.List;

import beans.Autor;
import beans.Noticia;

public interface AutorDAO {
	
	public Autor insert(Autor autor) throws SQLException, ClassNotFoundException;
	
	public Autor update(Autor autor) throws SQLException, ClassNotFoundException;
	
	public boolean delete(long id) throws ClassNotFoundException, SQLException;
	
	public List<Autor> findAll() throws SQLException, ClassNotFoundException;
	
	public Autor findById(long id) throws SQLException, ClassNotFoundException;	
	
	public List<Noticia> findAllNoticias( long id) throws SQLException, ClassNotFoundException;

	public Autor login(String login, String senha) throws SQLException, ClassNotFoundException;

}
