package dbclass;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import beans.Tag;

public interface TagDAO {
	
	public Tag insert(Tag tag) throws SQLException, ClassNotFoundException;
	
	public Tag update(Tag tag) throws SQLException, ClassNotFoundException;
	
	public boolean delete(String nome) throws ClassNotFoundException, SQLException;
	
	public List<Tag> findAll() throws SQLException, ClassNotFoundException;
	
	public Tag findById(String nome) throws SQLException, ClassNotFoundException;

	public String findByIdNoticia(long id_noticia) throws SQLException, ClassNotFoundException ;
	public boolean deleteAll(Long id) throws ClassNotFoundException, SQLException ;
	public ResultSet nuvem() throws SQLException, ClassNotFoundException;

}
