package dbclass;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import beans.Imagem;
import beans.Video;
import beans.Voto;

public interface VotoDAO {
	
	public Voto insert(Voto voto) throws SQLException, ClassNotFoundException;
	
	public Voto update(Voto voto) throws SQLException, ClassNotFoundException;
	
	public boolean delete(long id) throws ClassNotFoundException, SQLException;
	
	public List<Voto> findAll() throws SQLException, ClassNotFoundException;
	
	public Voto findById(long id) throws SQLException, ClassNotFoundException;	

	public long avg(long id) throws SQLException, ClassNotFoundException;

	public ResultSet maisVotadas() throws SQLException, ClassNotFoundException;
	
}
