-- phpMyAdmin SQL Dump
-- version 3.1.1
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Tempo de Geração: Mar 17, 2009 as 10:38 
-- Versão do Servidor: 5.1.30
-- Versão do PHP: 5.2.8

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Banco de Dados: `sistemanoticia`
--

-- --------------------------------------------------------

--
-- Estrutura da tabela `autor`
--

CREATE TABLE IF NOT EXISTS `autor` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nome` varchar(60) NOT NULL,
  `login` varchar(60) NOT NULL,
  `senha` varchar(60) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=20 ;

--
-- Extraindo dados da tabela `autor`
--

INSERT INTO `autor` (`id`, `nome`, `login`, `senha`) VALUES
(1, 'Bruno', 'bruno', '123'),
(2, 'Alexandre', 'alexandre', 'qwe'),
(19, 'Ana', 'ana', '123');

-- --------------------------------------------------------

--
-- Estrutura da tabela `categoria`
--

CREATE TABLE IF NOT EXISTS `categoria` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `nome` varchar(60) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=38 ;

--
-- Extraindo dados da tabela `categoria`
--

INSERT INTO `categoria` (`id`, `nome`) VALUES
(3, 'Populares'),
(2, 'Economia'),
(10, 'Pessoas'),
(11, 'Dinheiro'),
(12, 'Medicina'),
(13, 'Ecologia'),
(14, 'Animais'),
(16, 'Jogos'),
(36, 'Internet');

-- --------------------------------------------------------

--
-- Estrutura da tabela `comentario`
--

CREATE TABLE IF NOT EXISTS `comentario` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `corpo` varchar(1024) NOT NULL,
  `data` datetime NOT NULL,
  `id_noticia` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=10 ;

--
-- Extraindo dados da tabela `comentario`
--

INSERT INTO `comentario` (`id`, `corpo`, `data`, `id_noticia`) VALUES
(5, 'Noticia Legal', '2009-03-16 00:00:00', 15),
(4, 'Nao acho legal.', '2009-03-16 00:00:00', 15),
(6, 'Noticia interessante, mas repetida.', '2009-03-16 00:00:00', 17),
(7, 'Melhor assi', '2009-03-16 00:00:00', 24),
(8, 'Boa noticia', '2009-03-16 00:00:00', 6),
(9, 'Teste', '2009-03-17 00:00:00', 24);

-- --------------------------------------------------------

--
-- Estrutura da tabela `imagem`
--

CREATE TABLE IF NOT EXISTS `imagem` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(500) NOT NULL,
  `titulo` varchar(60) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=21 ;

--
-- Extraindo dados da tabela `imagem`
--

INSERT INTO `imagem` (`id`, `url`, `titulo`) VALUES
(1, 'http://farm4.static.flickr.com/3598/3351694521_7bd7fc28fb.jpg', 'Raios'),
(3, 'http://farm4.static.flickr.com/3631/3350894957_e11b8acd3d.jpg', 'Mulher'),
(4, 'http://farm4.static.flickr.com/3603/3348085461_3f9df82a9e.jpg', 'Chute'),
(5, 'http://farm4.static.flickr.com/3431/3346920477_cb36e0882b.jpg', 'Cachoeira'),
(6, 'http://farm4.static.flickr.com/3649/3356627118_85312c95ee.jpg', 'Foto'),
(7, 'http://farm4.static.flickr.com/3590/3344707681_32b8213aa4.jpg', 'Praia'),
(8, 'http://farm1.static.flickr.com/174/465995881_cac00ecb1c.jpg', 'Sombra Feminina'),
(9, 'http://farm4.static.flickr.com/3107/3172550936_1c3f19bdbc.jpg', 'Por do Sol'),
(10, 'http://farm4.static.flickr.com/3443/3281111555_87a18b3811.jpg', 'Casamento'),
(11, 'http://farm4.static.flickr.com/3085/3152314531_10f7ca17cc.jpg', 'Black Jack'),
(12, 'http://farm4.static.flickr.com/3083/3152314471_7d39ab9ba3.jpg', 'Golfinho'),
(13, 'http://farm4.static.flickr.com/3278/3057444435_e94f46d57c.jpg', 'Miss'),
(17, 'http://farm1.static.flickr.com/107/252827331_8d8722a333.jpg', 'Futebol'),
(18, 'http://farm1.static.flickr.com/143/374705913_db106b13fa.jpg', 'Lula'),
(19, 'http://farm4.static.flickr.com/3262/2637738608_cd08444c16.jpg', 'Floresta'),
(20, 'http://farm4.static.flickr.com/3078/3110917437_6d5404fc3f.jpg', 'Clodovil');

-- --------------------------------------------------------

--
-- Estrutura da tabela `noticia`
--

CREATE TABLE IF NOT EXISTS `noticia` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `titulo` varchar(255) NOT NULL,
  `corpo` varchar(5000) NOT NULL,
  `data` datetime NOT NULL,
  `id_autor` int(11) NOT NULL,
  `id_categoria` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=27 ;

--
-- Extraindo dados da tabela `noticia`
--

INSERT INTO `noticia` (`id`, `titulo`, `corpo`, `data`, `id_autor`, `id_categoria`) VALUES
(6, 'O mercado imobiliário é o mais novo alvo de disputa entre a Caixa Econômica e BB', '<p>O mercado imobili&aacute;rio &eacute; o mais novo alvo de disputa entre a Caixa Econ&ocirc;mica Federal e o Banco do Brasil, segundo reportagem da <strong>Folha</strong> desta segunda-feira (<a href="http://www1.folha.uol.com.br/fsp/dinheiro/fi1802200815.htm">&iacute;ntegra do texto</a> exclusiva para assinantes do jornal e do UOL). A "briga", que tem esquentado os bastidores da equipe econ&ocirc;mica, &eacute; mais precisamente pelos financiamentos feitos sob as regras do SFH (Sistema Financeiro de Habita&ccedil;&atilde;o).</p>\r\n<p>O BB, que j&aacute; oferece financiamentos habitacionais em parceria com a Associa&ccedil;&atilde;o de Poupan&ccedil;a e Empr&eacute;stimo (Poupex), quer ampliar sua atua&ccedil;&atilde;o. Para isso, a institui&ccedil;&atilde;o precisa de autoriza&ccedil;&atilde;o do Banco Central para integrar o SFH e oferecer aos clientes a vantagem de utilizar o dinheiro depositado nas contas do FGTS (Fundo de Garantia por Tempo de Servi&ccedil;o) para abater no saldo devedor.</p>\r\n<p>L&iacute;der absoluta nesse segmento do SFH, a Caixa Econ&ocirc;mica Federal se ressentiu, e o clima esquentou entre os executivos das duas institui&ccedil;&otilde;es financeiras. Para a c&uacute;pula da Caixa, "n&atilde;o &eacute; razo&aacute;vel uma competi&ccedil;&atilde;o entre os bancos p&uacute;blicos" e prop&otilde;e a "especializa&ccedil;&atilde;o": a Caixa segue com financiamentos habitacionais, e o BB, com cr&eacute;dito rural.</p>', '2009-03-24 00:00:00', 1, 2),
(13, 'Obama quer impedir pagamento de US$ 165 mi de bônus da AIG', '<p>O presidente dos Estados Unidos, Barack Obama, disse nesta segunda-feira que pedir&aacute; ao Departamento do Tesouro para tentar impedir, "por todo meio legal", a seguradora AIG (American International Group) de <a href="http://www1.folha.uol.com.br/folha/dinheiro/ult91u534989.shtml">pagar US$ 165 milh&otilde;es</a> em bonifica&ccedil;&otilde;es a executivos.</p>\r\n<p>A AIG diz que os b&ocirc;nus fazem parte dos contratos dos executivos --incluindo daqueles respons&aacute;veis pelas divis&otilde;es da empresa que est&atilde;o mais envolvidas na crise em que a empresa se encontra. Como s&atilde;o cl&aacute;usulas contratuais, a AIG n&atilde;o pode simplesmente suspender o pagamento dos b&ocirc;nus.</p>\r\n<p><a href="http://www1.folha.uol.com.br/folha/especial/2008/crisenoseua/">Leia a cobertura completa da crise nos EUA</a><br /> <a href="http://www1.folha.uol.com.br/folha/dinheiro/ult91u498060.shtml">Entenda a evolu&ccedil;&atilde;o da crise que atinge a economia dos EUA</a></p>\r\n<p>A seguradora j&aacute; havia recebido US$ 150 bilh&otilde;es do governo quando foi anunciado um novo pacote de ajuda, no valor de US$ 30 bilh&otilde;es, no &uacute;ltimo dia 2 --mesmo dia em que a seguradora apresentou um <a href="http://www1.folha.uol.com.br/folha/dinheiro/ult91u511157.shtml">preju&iacute;zo de US$ 61,7 bilh&otilde;es</a> no quarto trimestre, o maior j&aacute; registrado por uma empresa americana. No ano passado como um todo, a AIG anunciou uma perda, tamb&eacute;m recorde, de US$ 99,289 bilh&otilde;es.</p>\r\n<p>"Nos &uacute;ltimos seis meses, a AIG recebeu somas substanciais do Departamento do Tesouro", disse Obama, que acrescentou que pediu ao secret&aacute;rio do Tesouro, Timothy Geithner, que use esse argumento e "busque todo meio legal para bloquear esses b&ocirc;nus". Obama disse ainda que a AIG &eacute; uma empresas "que se encontra em dificuldades financeiras devido &agrave; neglig&ecirc;ncia e &agrave; gan&acirc;ncia".</p>\r\n<p>"Nessas circunst&acirc;ncias &eacute; dif&iacute;cil entender como os operadores de derivativos na AIG tenham conseguido b&ocirc;nus, que dizer ent&atilde;o de US$ 165 milh&otilde;es em pagamento extra", afirmou o presidente. "Como eles justificam esse ultraje frente aos contribuintes que est&atilde;o mantendo a empresa em p&eacute;?"</p>\r\n<p>Representantes da Casa Branca disseram, segundo o di&aacute;rio americano "The New York Times" ("NYT"), que o governo n&atilde;o est&aacute; tentando levar a AIG &agrave; Justi&ccedil;a para impedir o pagamento dos b&ocirc;nus, mas que o Tesouro vai fazer com que a empresa se limite a pagar seus executivos dentro do estipulado em seus contratos.</p>', '2009-03-23 00:00:00', 1, 2),
(14, 'Físico da Nasa propõe banir o carvão e ataca meta alongada de Obama', '<p>O f&iacute;sico James Hansen ganhou fama mundial ap&oacute;s aparecer no document&aacute;rio "Uma Verdade Inconveniente" como o cientista que alertou o Congresso dos EUA de que o aquecimento global n&atilde;o era fic&ccedil;&atilde;o.</p>\r\n<p>Seu depoimento de 1988 &eacute; considerado um marco que facilitou a cria&ccedil;&atilde;o do Painel Intergovernamental de Mudan&ccedil;as Clim&aacute;ticas pela ONU naquele ano.</p>\r\n<p>Hoje, Hansen &eacute; um dos cientistas que defendem medidas dr&aacute;sticas contra o aquecimento, como altas taxas sobre combust&iacute;veis f&oacute;sseis e o banimento do carv&atilde;o mineral. Diretor do Instituto Goddard de Estudos Espaciais, da Nasa, &eacute; respons&aacute;vel por uma revis&atilde;o anual da temperatura do globo.</p>\r\n<p>Hansen mostrou que 2008 foi um ano particularmente frio, mas que isso n&atilde;o significa que o efeito estufa tenha freado. "Este ano e o pr&oacute;ximo provavelmente ser&atilde;o os mais quentes j&aacute; registrados", diz.</p>\r\n<p>Em entrevista concedida durante sua passagem pelo Congresso Cient&iacute;fico Internacional de Mudan&ccedil;as Clim&aacute;ticas, na semana passada, em Copenhague, Hansen criticou a proposta de Barack Obama para o novo acordo clim&aacute;tico e explicou por que considera o Protocolo de Kyoto uma falha.</p>\r\n<p class="star">*</p>\r\n<p><strong>Folha - O sr. tem ganho exposi&ccedil;&atilde;o na m&iacute;dia com frases como "usinas de carv&atilde;o s&atilde;o f&aacute;bricas da morte". Isso &eacute; uma estrat&eacute;gia deliberada?</strong></p>\r\n<p><strong>James Hansen -</strong> Tento acordar as pessoas. Podemos usar a met&aacute;fora do sapo e da &aacute;gua quente: se voc&ecirc; aquece &aacute;gua numa panela com um sapo dentro, ele se deixa cozinhar, mas se ele cai direto em &aacute;gua fervente pula fora. A humanidade est&aacute; permitindo cozinhar a si pr&oacute;pria. Ela continua queimando combust&iacute;veis f&oacute;sseis, o que levar&aacute; a uma situa&ccedil;&atilde;o sem controle para os nossos filhos e para os nossos netos.</p>\r\n<p>Eu tinha parado de falar com a m&iacute;dia ap&oacute;s testemunhar no Congresso em 1988. Situa&ccedil;&otilde;es como aquela nos distanciam da ci&ecirc;ncia. N&atilde;o gostei daquilo, n&atilde;o sou uma pessoa que gosta de falar na m&iacute;dia. Por 15 anos n&atilde;o dei nenhuma entrevista em TV.</p>\r\n<p>Mas em 2004, cheguei a uma conclus&atilde;o diferente.</p>', '2009-03-22 00:00:00', 1, 13),
(15, 'Orkut perde sua maior comunidade para troca de músicas', '<p>Quase 1 milh&atilde;o de internautas amanheceram nesta segunda-feira (16) com uma comunidade a menos no seu Orkut. Ap&oacute;s meses de queda de bra&ccedil;o com representantes das gravadoras, a comunidade <a href="http://www1.folha.uol.com.br/folha/informatica/ult124u455850.shtml">"Discografias"</a> anunciou, no domingo &agrave; noite, seu fim.</p>\r\n<p>Criado em novembro de 2005, o endere&ccedil;o abrigava 921 mil usu&aacute;rios cadastrados --o n&uacute;mero de pessoas que a utiliza efetivamente ultrapassava 1 milh&atilde;o, j&aacute; que para acessar seu f&oacute;rum n&atilde;o &eacute; preciso se inscrever. Ali, internautas compartilhavam links com &aacute;lbuns musicais inteiros sem pagar nada. A organiza&ccedil;&atilde;o e o volume de material fez com que o endere&ccedil;o se tornasse uma das principais plataformas na web brasileira para quem procura esse tipo de conte&uacute;do.</p>', '2009-03-26 00:00:00', 1, 36),
(16, 'Relatório mostra que 42% de matas perdidas em cinco anos no planeta são do Brasil', '<p>O Brasil registrou a maior perda absoluta de floresta no mundo entre 2000 e 2005 e 42% de hectares de mata cortada no planeta nesses anos ocorreu dentro do territ&oacute;rio nacional. A conclus&atilde;o &eacute; da Organiza&ccedil;&atilde;o das Na&ccedil;&otilde;es Unidas para Agricultura e Alimenta&ccedil;&atilde;o (FAO), que destaca que os lucros com a expans&atilde;o da agricultura e do etanol continuar&atilde;o a predominar nos pr&oacute;ximos anos sobre a tentativa de frear o desmatamento e toda a Am&eacute;rica do Sul continuar&aacute; a perder sua cobertura florestal. <br /><br />No mundo, a FAO alerta que a crise internacional deve aumentar a vulnerabilidade das florestas e secar os financiamentos para projetos ambientais. <br /><br /><strong>200 km&sup2; a menos por dia</strong><br /><br />Entre 2000 e 2005, 200 quil&ocirc;metros quadrados de florestas foram perdidos no mundo a cada dia e o temor &eacute; de que os investimentos em manejo sustent&aacute;vel sejam substitu&iacute;dos por uma explora&ccedil;&atilde;o ilegal de madeira. <br /><br />Segundo a FAO, o Brasil perdeu 3,1 milh&otilde;es de hectares de florestas por ano no per&iacute;odo. Isso significou uma redu&ccedil;&atilde;o anual de 0,6% na cobertura florestal. O &oacute;rg&atilde;o da ONU informou que o Pa&iacute;s observou uma acelera&ccedil;&atilde;o no desmatamento em compara&ccedil;&atilde;o ao per&iacute;odo entre 1995 e 2000. Naqueles anos, a perda de floresta foi de 2,6 milh&otilde;es de hectares por ano, 0,5% da cobertura. <br /><br />No mundo, a perda florestal chegou a 7,3 milh&otilde;es por ano, 200 quil&ocirc;metros quadrados por dia. Isso representou 0,18% do territ&oacute;rio por ano. <br /><br />O ritmo de desmatamento no Brasil, portanto, foi seis vezes superior &agrave; m&eacute;dia mundial e o crescimento das exporta&ccedil;&otilde;es de grande escala de soja, biocombust&iacute;veis e carnes &eacute; considerada pela entidade como "respons&aacute;vel pela grande parte do desmatamento da regi&atilde;o". O levantamento conclui ainda que 75% do desmatamento na Am&eacute;rica do Sul ocorreu no Brasil. <br /><br />Em compara&ccedil;&atilde;o a outros pa&iacute;ses, o Brasil lidera amplamente com a maior &aacute;rea desmatada no planeta, mesmo que seu territ&oacute;rio ainda esteja coberto por floresta em 57,2%.</p>', '2009-03-17 00:00:00', 1, 13),
(17, 'Criminosos assaltam pousada em Búzios e roubam 30 turistas argentinos', '<p>Um grupo de sete homens armados e encapuzados assaltou na         madrugada desta segunda-feira (16) a pousada Unic&oacute;rnio, na Praia         de Ferradura, em B&uacute;zios, na Regi&atilde;o dos Lagos. De acordo com a         pol&iacute;cia, cerca de 30 h&oacute;spedes argentinos ficaram sob a mira dos         criminosos por quase quatro horas e tiveram dinheiro, c&acirc;mera         fotogr&aacute;fica e outros pertences roubados.</p>\r\n<p>O delegado da 127&ordf;DP (B&uacute;zios), Jorge Veloso, n&atilde;o descarta a         participa&ccedil;&atilde;o de funcion&aacute;rios ou ex-empregados no assalto. De         acordo com a entrevista da turista assaltada Laura Guerra ao <a href="http://www.clarin.com/" target="_blank">jornal             argentino "Clar&iacute;n"</a>, os criminosos tinham         informa&ccedil;&otilde;es dos h&oacute;spedes.<br /> <br /> &ldquo;Eles tinham uma lista com as pessoas que tinham         crian&ccedil;as e nesses quartos eles n&atilde;o entraram. O estranho &eacute; que         essas pessoas poderiam ter escutado e chamado a pol&iacute;cia.         Entretanto, nos outros quartos que n&atilde;o tinham crian&ccedil;as, eles         roubaram nossos telefones e cortaram a linha telef&ocirc;nica&rdquo; afirmou         a turista. <br /> <br /> Segundo a reportagem do jornal "Clar&iacute;n",         o dono da pousada, que tamb&eacute;m &eacute; argentino, Roberto Pirrone, n&atilde;o         estava na pousada no momento da a&ccedil;&atilde;o. O propriet&aacute;rio estaria em         Buenos Aires e s&oacute; ficou sabendo do ocorrido por volta das 5h.<br /> <br /> &ldquo;Em B&uacute;zios jamais aconteceu uma coisa assim, &eacute; uma         coisa terr&iacute;vel. Estive com a pousada em obra por cinco anos e         nem os materiais foram roubados. N&atilde;o entendo, n&atilde;o sei o que         fazer nem o que dizer&rdquo; afirmou o dono da pousada ao jornal argentino.</p>\r\n<p>&nbsp;</p>', '2009-03-20 00:00:00', 1, 3),
(18, 'Receita anuncia que terá sistema de emissão de CPF em tempo real', '<p>O secret&aacute;rio-adjunto da Receita Federal, Otac&iacute;lio Cartaxo,         revelou nesta segunda-feira (16) que o &oacute;rg&atilde;o est&aacute; trabalhando em         um sistema que vai permitir, no futuro, a&nbsp;emiss&atilde;o do CPF         (Cadastro de Pessoa F&iacute;sica) em tempo real pelos agentes conveniados.</p>\r\n<p>"Hoje, a emiss&atilde;o do CPF &eacute; feita por meio de conv&ecirc;nios e o         contribuinte fica aguardando um tempo, em m&eacute;dia de 15         dias", disse Cartaxo. A expectativa do secret&aacute;rio-adjunto&nbsp;&eacute;         que esse servi&ccedil;o esteja dispon&iacute;vel para a popula&ccedil;&atilde;o dentro de         at&eacute; quatro meses.&nbsp;"O objetivo &eacute;&nbsp;esse. Emitir e         fazer&nbsp;retifica&ccedil;&otilde;es cadastrais no CPF em tempo real", acrescentou.</p>\r\n<p>Questionado sobre o custo que ser&aacute; cobrado, Cartaxo afirmou que         ainda n&atilde;o h&aacute; uma defini&ccedil;&atilde;o sobre o assunto.&nbsp;"N&atilde;o est&aacute;         decidido [se vai ser pago]", acrescentou.</p>\r\n<p class="materia-intertitulo"><strong>Como &eacute; atualmente</strong></p>\r\n<p>Atualmente, os contribuintes t&ecirc;m de se dirigir a uma unidade de         atendimento do Banco do Brasil, da Caixa Econ&ocirc;mica Federal, ou         dos Correios, para poder tirar o CPF. O custo do servi&ccedil;o &eacute; de R$         5,50. Para pessoas com mais de 18 anos, e menos de 70 anos de         idade, s&atilde;o necess&aacute;rios os seguintes documentos: documento de         identidade que comprove filia&ccedil;&atilde;o e&nbsp;t&iacute;tulo de eleitor ou certid&atilde;o         emitida pelo TRE, ou cart&oacute;rio eleitoral, atestando a         inexist&ecirc;ncia do alistamento eleitoral. Depois, aguardam o envio         do documento para sua resid&ecirc;ncia.</p>', '2009-03-16 00:00:00', 1, 11),
(19, 'Fritzl admite estupro e incesto, nega assassinato e culpa relação com a mãe', '<p>O austr&iacute;aco Josef Fritzl, acusado de sequestrar, estuprar e ter         sete filhos com sua pr&oacute;pria filha, declarou-se nesta         segunda-feira (16) culpado de estupro, incesto&nbsp;e sequestro, mas         negou em ju&iacute;zo&nbsp;a acusa&ccedil;&atilde;o de homic&iacute;dio de um de seus "filhos-netos"</p>\r\n<p>Fritzl, de 73 anos, tamb&eacute;m afirmou perante o         tribunal&nbsp;que n&atilde;o &eacute; culpado da acusa&ccedil;&atilde;o de "escravid&atilde;o".</p>\r\n<p>Falando ao tribunal no seu primeiro dia de julgamento, ele         relembrou sua dif&iacute;cil inf&acirc;ncia, quando teria sido maltratado         pela m&atilde;e.</p>', '2009-03-16 00:00:00', 1, 3),
(20, 'EUA lançam pacote de US$ 15 bilhões para pequenas e médias empresas', '<p>A Casa Branca anunciou nesta segunda-feira (16)&nbsp;um plano para         abrir o mercado de cr&eacute;dito para as pequenas e m&eacute;dias empresas         (PME), cujo dinamismo &eacute; considerado vital para a economia         americana. <br /> <br /> O Tesouro destinar&aacute; at&eacute; US$ 15 bilh&otilde;es para a         compra de t&iacute;tulos atrelados a empr&eacute;stimos concedidos &agrave;s PME,         para permitir que os emissores destes pap&eacute;is possam conceder         novos cr&eacute;ditos a empresas que estejam em condi&ccedil;&otilde;es de         reembols&aacute;-los, indicou a Casa Branca em comunicado.&nbsp;</p>\r\n<p class="materia-intertitulo"><strong>Primeiro passo</strong></p>\r\n<p>O presidente Barack Obama disse que a medida foi adotada em         resposta a uma situa&ccedil;&atilde;o na qual os "propriet&aacute;rios de         pequenas empresas enfrentam graves dificuldades embora dirijam         neg&oacute;cios rent&aacute;veis, pois suas linhas de cr&eacute;dito est&atilde;o         fechadas".</p>', '2009-03-16 00:00:00', 1, 11),
(21, 'Universidade expulsa 2 e suspende 7 por trote em SP', '<p>CAMPINAS - O Centro Universit&aacute;rio Anhanguera Educacional do munic&iacute;pio de Leme, a 189 quil&ocirc;metros de S&atilde;o Paulo, expulsou dois alunos e suspendeu outros sete como pena pela agress&otilde;es e constrangimento sofridos pelo calouro do curso de medicina veterin&aacute;ria Bruno C&eacute;sar Ferreira. Ele foi ferido com um chicote, recebeu chutes no abdome e na cabe&ccedil;a e foi internado na Santa Casa da cidade por ingest&atilde;o de bebida alco&oacute;lica, no dia 10 de fevereiro. Segundo o centro universit&aacute;rio, por meio de assessoria, as puni&ccedil;&otilde;es foram comunicadas na sexta-feira aos alunos.<br /><br />De acordo com informa&ccedil;&otilde;es do inqu&eacute;rito policial, a agress&atilde;o ocorreu ap&oacute;s o trote organizado pelos veteranos, ocorrido fora das instala&ccedil;&otilde;es da faculdade. O exame de corpo de delito apontou a ingest&atilde;o de bebidas, mas descartou o coma alco&oacute;lico, como divulgado preliminarmente. A suspens&atilde;o dos sete estudantes durar&aacute; 15 dias. A universidade n&atilde;o revelou o nome dos punidos.<br /><br />O aluno agredido disse hoje que n&atilde;o dar&aacute; continuidade ao processo judicial contra os suspeitos de agress&atilde;o. "Eu imaginava que a faculdade ia suspender, n&atilde;o expulsar. N&atilde;o queria que tivesse acontecido isso (o trote violento), mas na minha opini&atilde;o a faculdade fez o papel dela", afirmou. O calouro disse que vai retirar a acusa&ccedil;&atilde;o, mas para se proteger registrou um boletim de ocorr&ecirc;ncia de amea&ccedil;a que teria recebido pela internet.</p>', '2009-03-25 00:00:00', 1, 10),
(22, 'Leandro Bomfim comemora nova fase no Fluminense', '<p>RIO - Diante de um panorama de experi&ecirc;ncias a serem feitas por Carlos Alberto Parreira - o t&eacute;cnico afirmara que dar&aacute; oportunidades para alguns jogadores do Fluminense visando a uma avalia&ccedil;&atilde;o mais ampla - um dos atletas que t&ecirc;m se destacado &eacute; Leandro Bomfim. Na partida contra o Maca&eacute;, a entrada do meio-campista no lugar de Romeu permitiu que a sa&iacute;da de bola da defesa para o ataque fosse mais r&aacute;pida.<br /><br />Independentemente de come&ccedil;ar como titular ou n&atilde;o, Leandro Bomfim vive nova fase nas Laranjeiras. A felicidade n&atilde;o se restringe somente as oportunidades que tem recebido desde a &eacute;poca de Ren&eacute; Sim&otilde;es. Para ele, trabalhar com um t&eacute;cnico gabaritado &eacute; visto como um fato positivo.<br /><br />"Est&aacute; sendo legal. Carlos Alberto Parreira &eacute; um treinador que ganhou v&aacute;rios t&iacute;tulos na carreira. Fico satisfeito de poder trabalhar com um t&eacute;cnico reverenciado no cen&aacute;rio nacional. &Eacute; ineg&aacute;vel a alegria de trabalhar com um t&eacute;cnico desse porte."<br /><br />Leandro Bomfim j&aacute; percebeu a import&acirc;ncia da chegada de Fred. O meio-campista, com passagem pelo futebol europeu, n&atilde;o tem d&uacute;vidas que o ex-atacante do Lyon vai lutar por uma vaga na Copa do Mundo da &Aacute;frica do Sul, em 2010.</p>', '2009-03-17 00:00:00', 1, 3),
(23, 'Lula: vamos continuar fortalecendo indústria automotiva', '<p>NOVA YORK - O presidente Luiz In&aacute;cio Lula da Silva disse n&atilde;o ver raz&atilde;o nenhuma para "n&atilde;o sermos otimistas com rela&ccedil;&atilde;o ao Brasil". Em entrevista coletiva &agrave; imprensa em Nova York, Lula descreveu o Pa&iacute;s como tendo "bancos muito s&oacute;lidos" e garantiu que vai continuar trabalhando para abrandar os efeitos da crise. Neste momento, "&eacute; o que eu disse para o Obama (Barack Obama, presidente dos EUA). Vamos trabalhar mais do que v&iacute;nhamos trabalhando, viajar mais do que est&aacute;vamos viajando e ser mais criativos do que fomos"<br /><br />Por isso, continuou Lula, "vou implementar com mais for&ccedil;a investimentos da Petrobras e do PAC (Programa de Acelera&ccedil;&atilde;o do Crescimento)". "E por isso tomamos medidas pra recuperar o setor automobil&iacute;stico." "No mercado interno, vamos continuar fortalecendo a ind&uacute;stria automobil&iacute;stica", afirmou.<br /><br />O presidente Lula reconheceu que o n&iacute;vel da meta de super&aacute;vit prim&aacute;rio "vai depender muito da capacidade de arrecada&ccedil;&atilde;o que o governo tiver". Ele descreve o &uacute;ltimo trimestre do ano como o per&iacute;odo mais dif&iacute;cil e reconhece que o n&uacute;mero de janeiro n&atilde;o atingiu o n&iacute;vel do ano passado.</p>', '2009-03-17 00:00:00', 1, 2),
(24, 'STJD suspende Otacílio Neto, do Corinthians, por 1 jogo', '<p>RIO - O atacante Otac&iacute;lio Neto foi julgado nesta segunda-feira pelo Superior Tribunal de Justi&ccedil;a Desportiva por sua expuls&atilde;o no jogo entre Itumbiara e Corinthians, na primeira fase da Copa do Brasil, e suspenso por apenas uma partida<br /><br />Com isso, Otac&iacute;lio Neto n&atilde;o poder&aacute; atuar no jogo de ida entre Misto, do Mato Grosso do Sul, e Corinthians pela segunda fase da competi&ccedil;&atilde;o nacional.<br /><br />O atacante foi expulso aos 44 minutos do segundo tempo ap&oacute;s chutar a bola para longe, ap&oacute;s a marca&ccedil;&atilde;o de falta para o Itumbiara. Por isso, foi denunciado no artigo 250 (praticar ato desleal ou inconveniente durante a partida) do C&oacute;digo Brasileiro de Justi&ccedil;a Desportiva, que prev&ecirc; suspens&atilde;o de uma a tr&ecirc;s partidas.</p>', '2009-03-16 00:00:00', 1, 3),
(25, 'Inflação pelo IPC-S desacelera em 4 de 7 capitais', '<p><span id="spanNoticia" class="tit">\r\n<p>A infla&ccedil;&atilde;o pelo &Iacute;ndice de Pre&ccedil;os ao Consumidor Semanal (IPC-S) desacelerou em quatro das sete capitais pesquisadas na segunda semana de mar&ccedil;o, informou nesta ter&ccedil;a-feira a Funda&ccedil;&atilde;o Get&uacute;lio Vargas (FGV). A menor infla&ccedil;&atilde;o do Pa&iacute;s foi a verificada em Bras&iacute;lia, que caiu de 0,11%, na pr&eacute;via anterior, para 0,02%, na atual.</p>\r\n<p>Em seguida, entre as desacelera&ccedil;&otilde;es, est&atilde;o o Rio de Janeiro (de 0,19% para 0,06%), Recife (de 0,7% para 0,5%) e Porto Alegre (de 0,88% para 0,84%). Na contram&atilde;o ficaram Salvador (de 0,24% para 0,31%), S&atilde;o Paulo (de 0,37% para 0,44%) e Belo Horizonte (de 0,31% para 0,61%).</p>\r\n<p>No geral, o IPC-S da segunda semana do m&ecirc;s teve infla&ccedil;&atilde;o de 0,37%, ante alta de 0,35% na abertura do m&ecirc;s. A principal press&atilde;o para a acelera&ccedil;&atilde;o veio dos alimentos, que aceleraram a alta de 0,24% para 0,37%.</p>\r\n<p>O IPC-S do per&iacute;odo foi calculado com base nos pre&ccedil;os coletados entre os dias 16 de fevereiro de 2009 e 15 de mar&ccedil;o de 2009, comparados aos coletados entre 16 de janeiro de 2009 e 15 de fevereiro de 2009.</p>\r\n</span></p>', '2009-03-17 00:00:00', 1, 10),
(26, 'Médicos trabalham com hipótese de morte cerebral de Clodovil', '<p>O estado de sa&uacute;de do deputado federal Clodovil Hernandes (PR-SP), internado desde a manh&atilde; de segunda-feira no Hospital Santa L&uacute;cia, em Bras&iacute;lia, continua grave, segundo boletim m&eacute;dico divulgado nesta manh&atilde;. Os m&eacute;dicos trabalham com a possibilidade de morte cerebral e informaram que Clodovil ser&aacute; submetido a exames nesta ter&ccedil;a-feira para avaliar o seu estado neurol&oacute;gico.</p>\r\n<p>O boletim m&eacute;dico divulgado &agrave;s 7h30 informa que o deputado segue em "coma profundo", apresentando quadro de "extrema gravidade". Os exames que ser&atilde;o realizados no decorrer do dia devem, segundo os m&eacute;dicos, medir "a gravidade da les&atilde;o cerebral e afastar a possibilidade de morte cerebral".</p>\r\n<p>O deputado foi internado &agrave;s 8h17 desta segunda-feira, ap&oacute;s ter sofrido um Acidente Vascular Cerebral (AVC). O deputado foi encontrado por um funcion&aacute;rio da casa onde mora em Bras&iacute;lia, por volta das 7h, ca&iacute;do ao lado da cama. Na tarde de ontem, o hospital informou que Clodovil teve uma parada cardiorrespirat&oacute;ria de cerca de cinco minutos por volta das 14h15, mas foi reanimado pela equipe m&eacute;dica. O estado de sa&uacute;de do deputado federal Clodovil Hernandes (PR-SP), internado desde a manh&atilde; de segunda-feira no Hospital Santa L&uacute;cia, em Bras&iacute;lia, continua grave, segundo boletim m&eacute;dico divulgado nesta manh&atilde;. Os m&eacute;dicos trabalham com a possibilidade de morte cerebral e informaram que Clodovil ser&aacute; submetido a exames nesta ter&ccedil;a-feira para avaliar o seu estado neurol&oacute;gico.</p>\r\n<p>O boletim m&eacute;dico divulgado &agrave;s 7h30 informa que o deputado segue em "coma profundo", apresentando quadro de "extrema gravidade". Os exames que ser&atilde;o realizados no decorrer do dia devem, segundo os m&eacute;dicos, medir "a gravidade da les&atilde;o cerebral e afastar a possibilidade de morte cerebral".</p>\r\n<p>O deputado foi internado &agrave;s 8h17 desta segunda-feira, ap&oacute;s ter sofrido um Acidente Vascular Cerebral (AVC). O deputado foi encontrado por um funcion&aacute;rio da casa onde mora em Bras&iacute;lia, por volta das 7h, ca&iacute;do ao lado da cama. Na tarde de ontem, o hospital informou que Clodovil teve uma parada cardiorrespirat&oacute;ria de cerca de cinco minutos por volta das 14h15, mas foi reanimado pela equipe m&eacute;dica.</p>', '2009-03-17 00:00:00', 1, 10);

-- --------------------------------------------------------

--
-- Estrutura da tabela `noticia_imagem`
--

CREATE TABLE IF NOT EXISTS `noticia_imagem` (
  `id_noticia` int(11) NOT NULL,
  `id_imagem` int(11) NOT NULL,
  PRIMARY KEY (`id_noticia`,`id_imagem`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Extraindo dados da tabela `noticia_imagem`
--

INSERT INTO `noticia_imagem` (`id_noticia`, `id_imagem`) VALUES
(6, 4),
(13, 5),
(14, 9),
(14, 11),
(15, 13),
(17, 9),
(20, 18),
(23, 18),
(24, 17),
(26, 20);

-- --------------------------------------------------------

--
-- Estrutura da tabela `noticia_video`
--

CREATE TABLE IF NOT EXISTS `noticia_video` (
  `id_noticia` int(11) NOT NULL,
  `id_video` int(11) NOT NULL,
  PRIMARY KEY (`id_noticia`,`id_video`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Extraindo dados da tabela `noticia_video`
--

INSERT INTO `noticia_video` (`id_noticia`, `id_video`) VALUES
(6, 3),
(15, 7),
(17, 10),
(22, 12);

-- --------------------------------------------------------

--
-- Estrutura da tabela `tag`
--

CREATE TABLE IF NOT EXISTS `tag` (
  `nome` varchar(60) NOT NULL DEFAULT '',
  `id_noticia` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Extraindo dados da tabela `tag`
--

INSERT INTO `tag` (`nome`, `id_noticia`) VALUES
('dinheiro', 6),
('caixa', 6),
('folha', 6),
('obama', 13),
('aig', 13),
('dinheiro', 13),
('nasa', 14),
('carvao', 14),
('fisico', 14),
('onu', 14),
('orkut', 15),
('internet', 15),
('discos', 15),
('brasil', 16),
('mata', 16),
('desmatamento', 16),
('assalto', 17),
('buzios', 17),
('roubo', 17),
('dinheiro', 18),
('receita federal', 18),
('estupro', 19),
('assalto', 19),
('violencia', 19),
('dinheiro', 20),
('credito', 20),
('tesouro', 20),
('obama', 20),
('banco do brasil', 6),
('imoveis', 6),
('brasil', 6),
('brasil', 17),
('cpf', 18),
('brasil', 18),
('violencia', 21),
('usp', 21),
('candidatos', 21),
('trote', 21),
('futebol', 22),
('bola', 22),
('rio de janeiro', 22),
('brasil', 22),
('lula', 23),
('automovel', 23),
('economia', 23),
('brasil', 23),
('futebol', 24),
('corinthians', 24),
('brasil', 24),
('inflacao', 25),
('ipca', 25),
('fgv', 25),
('clodovil', 26),
('morte', 26),
('medicos', 26),
('deoputado', 26),
('avc', 26);

-- --------------------------------------------------------

--
-- Estrutura da tabela `video`
--

CREATE TABLE IF NOT EXISTS `video` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `url` varchar(500) NOT NULL,
  `titulo` varchar(60) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=13 ;

--
-- Extraindo dados da tabela `video`
--

INSERT INTO `video` (`id`, `url`, `titulo`) VALUES
(1, 'http://www.youtube.com/watch?v=Ktgsn_G59os', 'Danca do Quadrado'),
(3, 'http://www.youtube.com/watch?v=wDiUG52ZyHQ', '300 de Esparta'),
(4, 'http://www.youtube.com/watch?v=6M3skID44Gg', 'Beatles'),
(5, 'http://www.youtube.com/watch?v=JCo8KLjZhDY', 'Halo'),
(6, 'http://www.youtube.com/watch?v=kq4SqgxIKM0', 'Highlander'),
(7, 'http://www.youtube.com/watch?v=6Q3ltyPJJMQ', 'Beleza Americana'),
(9, 'http://www.youtube.com/watch?v=LM2BwoWce78', 'Jump Shot'),
(10, 'http://www.youtube.com/watch?v=gnOnQF91gVs', 'Abrir Cerveja'),
(12, 'http://www.youtube.com/watch?v=RuFD-sPKigE', 'Fluminense');

-- --------------------------------------------------------

--
-- Estrutura da tabela `voto`
--

CREATE TABLE IF NOT EXISTS `voto` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ip` varchar(60) NOT NULL,
  `nota` int(11) NOT NULL,
  `id_noticia` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=32 ;

--
-- Extraindo dados da tabela `voto`
--

INSERT INTO `voto` (`id`, `ip`, `nota`, `id_noticia`) VALUES
(2, '222.2.22.2', 5, 3),
(3, '33.3.3.33', 4, 2),
(4, '127.0.0.1', 3, 15),
(5, '127.0.0.1', 5, 15),
(6, '127.0.0.1', 5, 6),
(7, '127.0.0.1', 5, 6),
(8, '127.0.0.1', 2, 13),
(9, '127.0.0.1', 2, 13),
(10, '127.0.0.1', 5, 6),
(11, '127.0.0.1', 3, 6),
(12, '127.0.0.1', 3, 14),
(13, '127.0.0.1', 4, 24),
(14, '127.0.0.1', 3, 14),
(15, '127.0.0.1', 5, 15),
(16, '127.0.0.1', 5, 6),
(17, '127.0.0.1', 5, 6),
(18, '127.0.0.1', 5, 6),
(19, '127.0.0.1', 3, 15),
(20, '127.0.0.1', 5, 15),
(21, '127.0.0.1', 5, 16),
(22, '127.0.0.1', 2, 6),
(23, '127.0.0.1', 5, 16),
(24, '127.0.0.1', 5, 20),
(25, '127.0.0.1', 5, 20),
(26, '127.0.0.1', 1, 20),
(27, '127.0.0.1', 4, 24),
(28, '127.0.0.1', 3, 6),
(29, '127.0.0.1', 5, 13),
(30, '127.0.0.1', 5, 26),
(31, '127.0.0.1', 4, 26);
